/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef STATE_H
#define STATE_H

#include <irrlicht/irrlicht.h>

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Classes
class StateClass {

	public:

		// Setup functions
		virtual int Init() = 0;
		virtual int Close() = 0;

		// Events
		virtual bool HandleKeyPress(EKEY_CODE TKey) = 0;
		virtual bool HandleKeyLift(EKEY_CODE TKey) = 0;
		virtual void HandleMouseMotion(float TUpdateX, float TUpdateY) = 0;
		virtual bool HandleMousePress(int TButton, int TMouseX, int TMouseY) = 0;
		virtual void HandleMouseLift(int TButton, int TMouseX, int TMouseY) = 0;
		virtual void HandleMouseWheel(float TDirection) = 0;
		virtual void HandleGUI(EGUI_EVENT_TYPE TEventType, IGUIElement *TElement) = 0;
		
		// Update
		virtual void Update(u32 TDeltaTime) = 0;
		virtual void Draw() = 0;

	private:

};

#endif
