/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#include "default.h"
#include "../engine/physics.h"

void DefaultObjectStruct::Reset() {

	// Generic properties
	Type = ObjectClass::NONE;
	Name = File = "";
	Lifetime = -1.0f;
	Visible = 1;
	Hookable = true;

	// Collision
	CollisionCallback = "";
	CollisionGroup = PhysicsClass::FILTER_DEFAULT | PhysicsClass::FILTER_CAMERA;
	CollisionMask = PhysicsClass::FILTER_BASICBODIES | PhysicsClass::FILTER_GRAPPLE | PhysicsClass::FILTER_ZONE;

	// Orientation
	Position.set(0.0f, 0.0f, 0.0f);
	Rotation.set(0.0f, 0.0f, 0.0f);
	
	// Physical properties
	Scale.set(1.0f, 1.0f, 1.0f);
	Radius = 0.5f;
	Mass = 1.0f;
	Friction = 1.0f;
	LinearDamping = 0.0f;
	AngularDamping = 0.5f;
	SpringDistance = 0.0f;
	SpringConstant = 1.0f;

	// Graphics
	Texture = DetailTexture = "";
	Lighting = Fog = 0;

	// Zones
	Active = 1;

	// Terrain
	SmoothFactor = 3;

	// Player
	TorqueFactor = 200.0f;
	GrappleEnabled = 0;

	// Joints
	LinearLimit[0].setValue(0.0f, 0.0f, 0.0f);
	LinearLimit[1].setValue(0.0f, 0.0f, 0.0f);
	AngularLimit[0].setValue(0.0f, 0.0f, 0.0f);
	AngularLimit[1].setValue(0.0f, 0.0f, 0.0f);
	BodyA = BodyB = NULL;
}
