/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef DEFAULTS_H
#define DEFAULTS_H

// Libraries
#include <irrlicht/irrlicht.h>
#include <bullet/btBulletCollisionCommon.h>
#include <bullet/btBulletDynamicsCommon.h>
#include "object.h"

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Forward Declarations
class RigidBodyClass;

struct DefaultObjectStruct {
	
	DefaultObjectStruct() { Reset(); }
	void Reset();

	// Generic properties
	ObjectClass::ObjectType Type;
	stringc Name, File;
	float Lifetime;
	int Visible;
	bool Hookable;

	// Collision
	stringc CollisionCallback;
	int CollisionGroup, CollisionMask;

	// Orientation
	vector3df Position, Rotation;
	
	// Physical properties
	vector3df Scale;
	f32 Radius;
	btScalar Mass, Friction;
	btScalar LinearDamping, AngularDamping;
	btScalar SpringDistance, SpringConstant;

	// Graphics
	stringc Texture, DetailTexture;
	int Lighting, Fog;

	// Zones
	int Active;

	// Terrain
	int SmoothFactor;
	
	// Player
	float TorqueFactor;
	int GrappleEnabled;

	// Joints
	btVector3 LinearLimit[2], AngularLimit[2];
	RigidBodyClass *BodyA, *BodyB;

};

#endif
