/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#include "object.h"
#include "default.h"
#include "../engine/game.h"

// Constructor
ObjectClass::ObjectClass()
:	Name(""),
	Type(NONE),
	Deleted(false),
	ID(-1) {

	Timer.Start();
}

// Destructor
ObjectClass::~ObjectClass() {

}

// Updates the object
void ObjectClass::Update(u32 TDeltaTime) {

	Timer.Update(TDeltaTime);

	// Check for expiration
	if(Lifetime > 0.0 && Timer.GetSeconds() > Lifetime)
		Deleted = true;
}

// Updates while replaying
void ObjectClass::UpdateReplay(u32 TDeltaTime) {
	
	Timer.Update(TDeltaTime);
}

// Sets object properties
void ObjectClass::SetProperties(DefaultObjectStruct &TObject) {

	Type = TObject.Type;
	Name = TObject.Name;
	Lifetime = TObject.Lifetime;
}
