/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef ORB_H
#define ORB_H

// Libraries
#include "rigidbody.h"

// Classes
class OrbClass : public RigidBodyClass {

	public:

		OrbClass(DefaultObjectStruct &TObject);
		~OrbClass();

		void Update(u32 TDeltaTime);
		void UpdateReplay(u32 TDeltaTime);

		void StartDeactivation(const stringc &TCallback, u32 TTime);
		bool GetDeactivated() const { return Deactivated; }
		bool GetDeactivating() const { return Deactivating; }

	private:

		void UpdateDeactivation();

		SColor GlowColor;
		IBillboardSceneNode *InnerNode;

		// Deactivation
		stringc DeactivationCallback;
		u32 DeactivationTime, DeactivationLength;
		bool Deactivated, Deactivating;
};

#endif
