/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef SPRINGJOINT_H
#define SPRINGJOINT_H

// Libraries
#include "object.h"
#include <irrlicht/irrlicht.h>
#include <bullet/btBulletCollisionCommon.h>
#include <bullet/btBulletDynamicsCommon.h>

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Classes
class SpringJointClass : public ObjectClass {

	public:

		SpringJointClass(DefaultObjectStruct &TObject);
		~SpringJointClass();

		void Update(u32 TDeltaTime);

	private:

		// Attributes
		btRigidBody *BodyA, *BodyB;
		btScalar SpringConstant, Distance, Damping;
		//btTypedConstraint *Joint;
	
};

#endif
