/*************************************************************************************
*	irrlamb - http://code.google.com/p/irrlamb/
*	Copyright (C) 2007  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef ZONE_H
#define ZONE_H

// Libraries
#include "object.h"
#include <irrlicht/irrlicht.h>
#include <bullet/btBulletCollisionCommon.h>
#include <bullet/btBulletDynamicsCommon.h>

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Holds data about a touched object
struct ObjectTouchState {

	ObjectTouchState() { }
	ObjectTouchState(ObjectClass *TObject, int TTouchCount) : Object(TObject), TouchCount(TTouchCount) { }

	ObjectClass *Object;
	int TouchCount;
};

// Classes
class ZoneClass : public ObjectClass {

	public:

		ZoneClass(DefaultObjectStruct &TObject);
		~ZoneClass();

		void EndFrame();
		virtual void HandleCollision(ObjectClass *TOtherObject, const btPersistentManifold *TContactManifold, float TNormalScale);

		void SetActive(bool TValue);

	private:

		// Attributes
		bool Active;

		// Physics
		btRigidBody *RigidBody;
		btCollisionShape *Shape;
		btDefaultMotionState *MotionState;

		// Touch state
		list<ObjectTouchState> TouchState;
		stringc CollisionCallback;

};

#endif
